#include "sighand.h"   /* itime() */
#include "spins.h"

static FILE *ft=NULL, *fb=NULL;  // file is left open
/* nr=1,2,3,... -1=close, v2.20 less sys-calls, mpi_task 0 only */
/* write tridiagonal matrix elements ta[i-1] tb[i-1] i=1... */
void outtri(int nr, double a, double b){ 
//  static FILE *ft=NULL, *fb=NULL;
  long t=itime();
  int r0=0;
  if (nr<=0) {
    if (ft) fclose(ft); if (fb) fclose(fb); ft=fb=NULL; if (nr<0) return;
  }
  if (/* nr<=1 &&*/ !ft) {
    // 2012-05-10 JS add checkpoint 4 (ToDo?)
    // open if not open, truncate to 0 on start, append after chkpt.resume
    ft=fopen("tmp/tri.txt",((nr<=1)?"wt":"at"));
    fb=fopen("tmp/tri.dat",((nr<=1)?"wb":"ab"));
    if (ft) setvbuf(ft,NULL,_IONBF,0);
    if (fb) setvbuf(fb,NULL,_IONBF,0); // needed for correct checkpointing
    if ((!ft) || (!fb)) { E0("fopen tmp/tri.{txt,dat}"); return; }
  }
  if (ft) fprintf(ft,"%3d %20.16f %20.16f %6.2fm\n",
                  nr, (double)a, (double)b, t/60.);
  if (fb)          r0=fwrite(&a,sizeof(double),1,fb); // ret=written_memb (1)
  if (fb && r0==1) r0=fwrite(&b,sizeof(double),1,fb);
  if (fb && r0!=1) E0("outtri write tri.dat");
  return;
}

/* restore tridiagonal matrix, n=MAX_ITR=dim */
/* JS2012-09-27 problem with double outputs if killed during checkpoint */
int loadtri(double *a, double *b, int n){
  // FILE *fb; 
  int last=0, nline=0, idx=0; char s2[256];
  outtri(-1,0,0); /* close open tri-files */
  fb= fopen("tmp/tri.dat","rb");
  ft= fopen("tmp/tri.txt","ra");  // new JS2012-09-27 try to fix bug
  if ((!fb) || (!ft)) {E0("fopen(tmp/tri.{dat,txt})");return 0;}
  while ((!feof(fb)) && (!feof(ft)) && last<n) { // unsure
    if (fread(a+last,sizeof(double),1,fb)!=1) break;
    if (fread(b+last,sizeof(double),1,fb)!=1) break;
    if (fgets(s2,256,ft)==NULL) break; // read max 255 chars incl. \n
    idx= atoi(s2);
//printf("DBG.loadtri.r line=%d idx=%d last=%d n=%d\n",nline+1,idx,last+1,n);
    // 0 1 0 ?, 1 2 1 ?
    nline++;  // num lines read (should be equal to $last)
    if (idx < last+1) {
      if (!mpi_i)
        printf("\nWARNING.loadtri idx=%d at line=%d ignored\n",idx,nline);
      continue; 
    }
    last++;   // last tridiag matrix element 
  }
  if (last  <n) { a[last  ]=0.0; b[last  ]=0.0; } // dbg fill ?
  if (last+1<n) { a[last+1]=0.0; b[last+1]=0.0; } // dbg fill ?
  fclose(fb); fb=NULL; /* do not close after checkpointing.resume?? */
  fclose(ft); ft=NULL; /* do not close after checkpointing.resume?? */
  /* ToDo: call last times outtri */
  return last; /* number of loaded tri-diag tupel */
}

